<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /><title>Grid Developer Guide</title><link rel="stylesheet" type="text/css" href="Common_Content/css/default.css" /><link rel="stylesheet" media="print" href="Common_Content/css/print.css" type="text/css" /><meta name="generator" content="publican 2.8" /><meta name="package" content="Red_Hat_Enterprise_MRG-Grid_Developer_Guide-2-en-US-1-3" /><meta name="description" content="This book contains information for developers using MRG Grid." /><script type="text/javascript" src="../../../../../toc.js"></script><script type="text/javascript">
              addID('Red_Hat_Enterprise_MRG');
              
	      addID('Red_Hat_Enterprise_MRG.2');
              
              addID('Red_Hat_Enterprise_MRG.2.books');
	      addID('Red_Hat_Enterprise_MRG.2.Grid_Developer_Guide');
              </script></head><body class="toc_embeded "><div id="tocdiv" class="toc"><iframe id="tocframe" class="toc" src="../../../../toc.html">This is an iframe, to view it upgrade your browser or enable iframe display.</iframe></div><p id="title"><a class="left" href="http://www.redhat.com/mrg/"><img src="Common_Content/images/image_left.png" alt="Product Site" /></a><a class="right" href="http://www.redhat.com/docs/en-US/Red_Hat_Enterprise_MRG"><img src="Common_Content/images/image_right.png" alt="Documentation Site" /></a></p><div xml:lang="en-US" class="book" id="id2836972" lang="en-US"><div class="titlepage"><div><div class="producttitle"><span class="productname">Red Hat Enterprise MRG</span> <span class="productnumber">2</span></div><div><h1 id="id2836972" class="title">Grid Developer Guide</h1></div><div><h2 class="subtitle">Developer-focused information for the Grid component of Red Hat Enterprise MRG</h2></div><p class="edition">Edition 1</p><div><h3 class="corpauthor">
		<span class="inlinemediaobject"><object data="Common_Content/images/title_logo.svg" type="image/svg+xml"> </object></span>

	</h3></div><div><div xml:lang="en-US" class="authorgroup" lang="en-US"><div class="author"><h3 class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></h3><div class="affiliation"><span class="orgname">Red Hat</span> <span class="orgdiv">Engineering Content Services</span></div><code class="email"><a class="email" href="mailto:alyoung@redhat.com">alyoung@redhat.com</a></code></div></div></div><hr /><div><div id="id3195179" class="legalnotice"><h1 class="legalnotice">Legal Notice</h1><div class="para">
		Copyright <span class="trademark"></span>© 2011 Red Hat, Inc.
	</div><div class="para">
		The text of and illustrations in this document are licensed by Red Hat under a Creative Commons Attribution–Share Alike 3.0 Unported license ("CC-BY-SA"). An explanation of CC-BY-SA is available at <a href="http://creativecommons.org/licenses/by-sa/3.0/">http://creativecommons.org/licenses/by-sa/3.0/</a>. In accordance with CC-BY-SA, if you distribute this document or an adaptation of it, you must provide the URL for the original version.
	</div><div class="para">
		Red Hat, as the licensor of this document, waives the right to enforce, and agrees not to assert, Section 4d of CC-BY-SA to the fullest extent permitted by applicable law.
	</div><div class="para">
		Red Hat, Red Hat Enterprise Linux, the Shadowman logo, JBoss, MetaMatrix, Fedora, the Infinity Logo, and RHCE are trademarks of Red Hat, Inc., registered in the United States and other countries.
	</div><div class="para">
		<span class="trademark">Linux</span>® is the registered trademark of Linus Torvalds in the United States and other countries.
	</div><div class="para">
		<span class="trademark">Java</span>® is a registered trademark of Oracle and/or its affiliates.
	</div><div class="para">
		<span class="trademark">XFS</span>® is a trademark of Silicon Graphics International Corp. or its subsidiaries in the United States and/or other countries.
	</div><div class="para">
		<span class="trademark">MySQL</span>® is a registered trademark of MySQL AB in the United States, the European Union and other countries.
	</div><div class="para">
		All other trademarks are the property of their respective owners.
	</div><div class="para">
		
<div class="address"><p><br />
			<span class="street">1801 Varsity Drive</span><br />
			 <span class="city">Raleigh</span>, <span class="state">NC</span> <span class="postcode">27606-2072</span> <span class="country">USA</span><br />
			 <span class="phone">Phone: +1 919 754 3700</span><br />
			 <span class="phone">Phone: 888 733 4281</span><br />
			 <span class="fax">Fax: +1 919 754 3701</span><br />
<br />
</p></div>

	</div></div></div><div><div class="abstract"><h6>Abstract</h6><div class="para">
			This book contains information for developers using MRG Grid.
		</div></div></div></div><hr /></div><div class="toc"><dl><dt><span class="preface"><a href="#pref-Grid_Developer_Guide-Preface">Preface</a></span></dt><dd><dl><dt><span class="section"><a href="#id3031862">1. Document Conventions</a></span></dt><dd><dl><dt><span class="section"><a href="#id3593310">1.1. Typographic Conventions</a></span></dt><dt><span class="section"><a href="#id3041035">1.2. Pull-quote Conventions</a></span></dt><dt><span class="section"><a href="#id2887066">1.3. Notes and Warnings</a></span></dt></dl></dd><dt><span class="section"><a href="#sect_RedHat-Getting_Help_and_Giving_Feedback">2. Getting Help and Giving Feedback</a></span></dt><dd><dl><dt><span class="section"><a href="#sect_RedHat-Do_You_Need_Help">2.1. Do You Need Help?</a></span></dt><dt><span class="section"><a href="#sect-RedHat-We_Need_Feedback">2.2. We Need Feedback!</a></span></dt></dl></dd></dl></dd><dt><span class="chapter"><a href="#chap-Grid_Developer_Guide-Overview">1. Overview</a></span></dt><dt><span class="chapter"><a href="#chap-Grid_Developer_Guide-API_Types">2. API Types</a></span></dt><dd><dl><dt><span class="section"><a href="#sect-Grid_Developer_Guide-API_Types-SOAP_and_WSDL">2.1. SOAP and WSDL</a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-API_Types-Aviary_Model">2.2. Aviary Model</a></span></dt></dl></dd><dt><span class="chapter"><a href="#chap-Grid_Developer_Guide-Aviary_Installation_and_Configuration">3. Aviary Installation and Configuration</a></span></dt><dd><dl><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Installation_and_Configuration-Installation">3.1. Installation</a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Installation_and_Configuration-Configuration">3.2. Configuration</a></span></dt></dl></dd><dt><span class="chapter"><a href="#chap-Grid_Developer_Guide-Aviary_Core_Types">4. Aviary Core Types</a></span></dt><dd><dl><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Core_Types-JobID">4.1. <em class="parameter"><code>JobId</code></em></a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Core_Types-SubmissionID">4.2. <em class="parameter"><code>SubmissionId</code></em></a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Core_Types-Attribute">4.3. <em class="parameter"><code>Attribute</code></em></a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Core_Types-JobStatus">4.4. <em class="parameter"><code>JobStatus</code></em></a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Core_Types-ResourceConstraint">4.5. <em class="parameter"><code>ResourceConstraint</code></em></a></span></dt></dl></dd><dt><span class="chapter"><a href="#chap-Grid_Developer_Guide-Job_Submission_Management">5. Job Submission and Management</a></span></dt><dt><span class="chapter"><a href="#chap-Grid_Developer_Guide-Job_Data_Queries">6. Job Data Queries</a></span></dt><dt><span class="chapter"><a href="#chap-Grid_Developer_Guide-Security">7. Security</a></span></dt><dt><span class="chapter"><a href="#chap-Grid_Developer_Guide-Client_Examples">8. Client Examples</a></span></dt><dd><dl><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Client_Examples-SOAP">8.1. SOAP XML</a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Client_Examples-Ruby">8.2. Ruby</a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Client_Examples-Python">8.3. Python</a></span></dt></dl></dd><dt><span class="chapter"><a href="#chap-Grid_Developer_Guide-More_Information">9. More Information</a></span></dt><dt><span class="appendix"><a href="#appe-Grid_Developer_Guide-Revision_History">A. Revision History</a></span></dt></dl></div><div xml:lang="en-US" class="preface" id="pref-Grid_Developer_Guide-Preface" lang="en-US"><div class="titlepage"><div><div><h1 class="title">Preface</h1></div></div></div><div xml:lang="en-US" class="section" lang="en-US"><div class="titlepage"><div><div><h2 class="title" id="id3031862">1. Document Conventions</h2></div></div></div><div class="para">
		This manual uses several conventions to highlight certain words and phrases and draw attention to specific pieces of information.
	</div><div class="para">
		In PDF and paper editions, this manual uses typefaces drawn from the <a href="https://fedorahosted.org/liberation-fonts/">Liberation Fonts</a> set. The Liberation Fonts set is also used in HTML editions if the set is installed on your system. If not, alternative but equivalent typefaces are displayed. Note: Red Hat Enterprise Linux 5 and later includes the Liberation Fonts set by default.
	</div><div class="section"><div class="titlepage"><div><div><h3 class="title" id="id3593310">1.1. Typographic Conventions</h3></div></div></div><div class="para">
			Four typographic conventions are used to call attention to specific words and phrases. These conventions, and the circumstances they apply to, are as follows.
		</div><div class="para">
			<code class="literal">Mono-spaced Bold</code>
		</div><div class="para">
			Used to highlight system input, including shell commands, file names and paths. Also used to highlight keycaps and key combinations. For example:
		</div><div class="blockquote"><blockquote class="blockquote"><div class="para">
				To see the contents of the file <code class="filename">my_next_bestselling_novel</code> in your current working directory, enter the <code class="command">cat my_next_bestselling_novel</code> command at the shell prompt and press <span class="keycap"><strong>Enter</strong></span> to execute the command.
			</div></blockquote></div><div class="para">
			The above includes a file name, a shell command and a keycap, all presented in mono-spaced bold and all distinguishable thanks to context.
		</div><div class="para">
			Key combinations can be distinguished from keycaps by the hyphen connecting each part of a key combination. For example:
		</div><div class="blockquote"><blockquote class="blockquote"><div class="para">
				Press <span class="keycap"><strong>Enter</strong></span> to execute the command.
			</div><div class="para">
				Press <span class="keycap"><strong>Ctrl</strong></span>+<span class="keycap"><strong>Alt</strong></span>+<span class="keycap"><strong>F2</strong></span> to switch to the first virtual terminal. Press <span class="keycap"><strong>Ctrl</strong></span>+<span class="keycap"><strong>Alt</strong></span>+<span class="keycap"><strong>F1</strong></span> to return to your X-Windows session.
			</div></blockquote></div><div class="para">
			The first paragraph highlights the particular keycap to press. The second highlights two key combinations (each a set of three keycaps with each set pressed simultaneously).
		</div><div class="para">
			If source code is discussed, class names, methods, functions, variable names and returned values mentioned within a paragraph will be presented as above, in <code class="literal">mono-spaced bold</code>. For example:
		</div><div class="blockquote"><blockquote class="blockquote"><div class="para">
				File-related classes include <code class="classname">filesystem</code> for file systems, <code class="classname">file</code> for files, and <code class="classname">dir</code> for directories. Each class has its own associated set of permissions.
			</div></blockquote></div><div class="para">
			<span class="application"><strong>Proportional Bold</strong></span>
		</div><div class="para">
			This denotes words or phrases encountered on a system, including application names; dialog box text; labeled buttons; check-box and radio button labels; menu titles and sub-menu titles. For example:
		</div><div class="blockquote"><blockquote class="blockquote"><div class="para">
				Choose <span class="guimenu"><strong>System</strong></span> → <span class="guisubmenu"><strong>Preferences</strong></span> → <span class="guimenuitem"><strong>Mouse</strong></span> from the main menu bar to launch <span class="application"><strong>Mouse Preferences</strong></span>. In the <span class="guilabel"><strong>Buttons</strong></span> tab, click the <span class="guilabel"><strong>Left-handed mouse</strong></span> check box and click <span class="guibutton"><strong>Close</strong></span> to switch the primary mouse button from the left to the right (making the mouse suitable for use in the left hand).
			</div><div class="para">
				To insert a special character into a <span class="application"><strong>gedit</strong></span> file, choose <span class="guimenu"><strong>Applications</strong></span> → <span class="guisubmenu"><strong>Accessories</strong></span> → <span class="guimenuitem"><strong>Character Map</strong></span> from the main menu bar. Next, choose <span class="guimenu"><strong>Search</strong></span> → <span class="guimenuitem"><strong>Find…</strong></span> from the <span class="application"><strong>Character Map</strong></span> menu bar, type the name of the character in the <span class="guilabel"><strong>Search</strong></span> field and click <span class="guibutton"><strong>Next</strong></span>. The character you sought will be highlighted in the <span class="guilabel"><strong>Character Table</strong></span>. Double-click this highlighted character to place it in the <span class="guilabel"><strong>Text to copy</strong></span> field and then click the <span class="guibutton"><strong>Copy</strong></span> button. Now switch back to your document and choose <span class="guimenu"><strong>Edit</strong></span> → <span class="guimenuitem"><strong>Paste</strong></span> from the <span class="application"><strong>gedit</strong></span> menu bar.
			</div></blockquote></div><div class="para">
			The above text includes application names; system-wide menu names and items; application-specific menu names; and buttons and text found within a GUI interface, all presented in proportional bold and all distinguishable by context.
		</div><div class="para">
			<code class="command"><em class="replaceable"><code>Mono-spaced Bold Italic</code></em></code> or <span class="application"><strong><em class="replaceable"><code>Proportional Bold Italic</code></em></strong></span>
		</div><div class="para">
			Whether mono-spaced bold or proportional bold, the addition of italics indicates replaceable or variable text. Italics denotes text you do not input literally or displayed text that changes depending on circumstance. For example:
		</div><div class="blockquote"><blockquote class="blockquote"><div class="para">
				To connect to a remote machine using ssh, type <code class="command">ssh <em class="replaceable"><code>username</code></em>@<em class="replaceable"><code>domain.name</code></em></code> at a shell prompt. If the remote machine is <code class="filename">example.com</code> and your username on that machine is john, type <code class="command">ssh john@example.com</code>.
			</div><div class="para">
				The <code class="command">mount -o remount <em class="replaceable"><code>file-system</code></em></code> command remounts the named file system. For example, to remount the <code class="filename">/home</code> file system, the command is <code class="command">mount -o remount /home</code>.
			</div><div class="para">
				To see the version of a currently installed package, use the <code class="command">rpm -q <em class="replaceable"><code>package</code></em></code> command. It will return a result as follows: <code class="command"><em class="replaceable"><code>package-version-release</code></em></code>.
			</div></blockquote></div><div class="para">
			Note the words in bold italics above — username, domain.name, file-system, package, version and release. Each word is a placeholder, either for text you enter when issuing a command or for text displayed by the system.
		</div><div class="para">
			Aside from standard usage for presenting the title of a work, italics denotes the first use of a new and important term. For example:
		</div><div class="blockquote"><blockquote class="blockquote"><div class="para">
				Publican is a <em class="firstterm">DocBook</em> publishing system.
			</div></blockquote></div></div><div class="section"><div class="titlepage"><div><div><h3 class="title" id="id3041035">1.2. Pull-quote Conventions</h3></div></div></div><div class="para">
			Terminal output and source code listings are set off visually from the surrounding text.
		</div><div class="para">
			Output sent to a terminal is set in <code class="computeroutput">mono-spaced roman</code> and presented thus:
		</div><pre class="screen">books        Desktop   documentation  drafts  mss    photos   stuff  svn
books_tests  Desktop1  downloads      images  notes  scripts  svgs</pre><div class="para">
			Source-code listings are also set in <code class="computeroutput">mono-spaced roman</code> but add syntax highlighting as follows:
		</div><pre class="programlisting">package org.<span class="perl_Function">jboss</span>.<span class="perl_Function">book</span>.<span class="perl_Function">jca</span>.<span class="perl_Function">ex1</span>;

<span class="perl_Keyword">import</span> javax.naming.InitialContext;

<span class="perl_Keyword">public</span> <span class="perl_Keyword">class</span> ExClient
{
   <span class="perl_Keyword">public</span> <span class="perl_DataType">static</span> <span class="perl_DataType">void</span> <span class="perl_Function">main</span>(String args[]) 
       <span class="perl_Keyword">throws</span> Exception
   {
      InitialContext iniCtx = <span class="perl_Keyword">new</span> InitialContext();
      Object         ref    = iniCtx.<span class="perl_Function">lookup</span>(<span class="perl_String">"EchoBean"</span>);
      EchoHome       home   = (EchoHome) ref;
      Echo           echo   = home.<span class="perl_Function">create</span>();

      System.<span class="perl_Function">out</span>.<span class="perl_Function">println</span>(<span class="perl_String">"Created Echo"</span>);

      System.<span class="perl_Function">out</span>.<span class="perl_Function">println</span>(<span class="perl_String">"Echo.echo('Hello') = "</span> + echo.<span class="perl_Function">echo</span>(<span class="perl_String">"Hello"</span>));
   }
}</pre></div><div class="section"><div class="titlepage"><div><div><h3 class="title" id="id2887066">1.3. Notes and Warnings</h3></div></div></div><div class="para">
			Finally, we use three visual styles to draw attention to information that might otherwise be overlooked.
		</div><div class="note"><div class="admonition_header"><h2>Note</h2></div><div class="admonition"><div class="para">
				Notes are tips, shortcuts or alternative approaches to the task at hand. Ignoring a note should have no negative consequences, but you might miss out on a trick that makes your life easier.
			</div></div></div><div class="important"><div class="admonition_header"><h2>Important</h2></div><div class="admonition"><div class="para">
				Important boxes detail things that are easily missed: configuration changes that only apply to the current session, or services that need restarting before an update will apply. Ignoring a box labeled 'Important' will not cause data loss but may cause irritation and frustration.
			</div></div></div><div class="warning"><div class="admonition_header"><h2>Warning</h2></div><div class="admonition"><div class="para">
				Warnings should not be ignored. Ignoring warnings will most likely cause data loss.
			</div></div></div></div></div><div xml:lang="en-US" class="section" id="sect_RedHat-Getting_Help_and_Giving_Feedback" lang="en-US"><div class="titlepage"><div><div><h2 class="title" id="sect_RedHat-Getting_Help_and_Giving_Feedback">2. Getting Help and Giving Feedback</h2></div></div></div><div class="section" id="sect_RedHat-Do_You_Need_Help"><div class="titlepage"><div><div><h3 class="title" id="sect_RedHat-Do_You_Need_Help">2.1. Do You Need Help?</h3></div></div></div><a id="id3658793" class="indexterm"></a><div class="para">
			If you experience difficulty with a procedure described in this documentation, visit the Red Hat Customer Portal at <a href="http://access.redhat.com">http://access.redhat.com</a>. Through the customer portal, you can:
		</div><div class="itemizedlist"><ul><li class="listitem"><div class="para">
					search or browse through a knowledgebase of technical support articles about Red Hat products.
				</div></li><li class="listitem"><div class="para">
					submit a support case to Red Hat Global Support Services (GSS).
				</div></li><li class="listitem"><div class="para">
					access other product documentation.
				</div></li></ul></div><div class="para">
			Red Hat also hosts a large number of electronic mailing lists for discussion of Red Hat software and technology. You can find a list of publicly available mailing lists at <a href="https://www.redhat.com/mailman/listinfo">https://www.redhat.com/mailman/listinfo</a>. Click on the name of any mailing list to subscribe to that list or to access the list archives.
		</div></div><div class="section" id="sect-RedHat-We_Need_Feedback"><div class="titlepage"><div><div><h3 class="title" id="sect-RedHat-We_Need_Feedback">2.2. We Need Feedback!</h3></div></div></div><a id="id2994532" class="indexterm"></a><div class="para">
			If you find a typographical error in this manual, or if you have thought of a way to make this manual better, we would love to hear from you! Please submit a report in Bugzilla: <a href="http://bugzilla.redhat.com/">http://bugzilla.redhat.com/</a> against the product <span class="application"><strong>Red Hat Enterprise MRG.</strong></span>
		</div><div class="para">
			When submitting a bug report, be sure to mention the manual's identifier: <em class="citetitle">Grid_Developer_Guide</em>
		</div><div class="para">
			If you have a suggestion for improving the documentation, try to be as specific as possible when describing it. If you have found an error, please include the section number and some of the surrounding text so we can find it easily.
		</div></div></div></div><div xml:lang="en-US" class="chapter" id="chap-Grid_Developer_Guide-Overview" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 1. Overview</h2></div></div></div><div class="para">
		MRG Grid provides a web service interface for job submission, management and queries called Aviary. This interface is designed to remove some of MRG Grid's complexity and provide access using universal network such as HTTP. Aviary uses SOAP for request and response exchanges between MRG Grid, Aviary-enabled components, and web service clients. Web service clients can be developed using Java, Python, Ruby, or other languages.
	</div><div class="para">
		Aviary is targeted at developers wanting to start using MRG Grid quickly. Developers wanting to use Aviary can do so without the depth of knowledge associated with MRG Grid's High Throughput Computing capabilities.
	</div></div><div xml:lang="en-US" class="chapter" id="chap-Grid_Developer_Guide-API_Types" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 2. API Types</h2></div></div></div><div class="toc"><dl><dt><span class="section"><a href="#sect-Grid_Developer_Guide-API_Types-SOAP_and_WSDL">2.1. SOAP and WSDL</a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-API_Types-Aviary_Model">2.2. Aviary Model</a></span></dt></dl></div><div class="section" id="sect-Grid_Developer_Guide-API_Types-SOAP_and_WSDL"><div class="titlepage"><div><div><h2 class="title" id="sect-Grid_Developer_Guide-API_Types-SOAP_and_WSDL">2.1. SOAP and WSDL</h2></div></div></div><div class="para">
			The API types are described using the SOAP XML schema and operations use the Web Services Description Language (WSDL). This schema-based approach allows developers to generate the code for types and operations into their preferred native programming language. Code is generated using a client web service toolkit. Some popular web service toolkits are: 
			<div class="itemizedlist"><ul><li class="listitem"><div class="para">
						Apache Axis or CXF to generate Java
					</div></li><li class="listitem"><div class="para">
						Suds to generate Python
					</div></li><li class="listitem"><div class="para">
						Savon to generate Ruby
					</div></li></ul></div>

		</div></div><div class="section" id="sect-Grid_Developer_Guide-API_Types-Aviary_Model"><div class="titlepage"><div><div><h2 class="title" id="sect-Grid_Developer_Guide-API_Types-Aviary_Model">2.2. Aviary Model</h2></div></div></div><div class="para">
			Entities of this API include <em class="parameter"><code>job</code></em>, <em class="parameter"><code>submission</code></em> and <em class="parameter"><code>attribute</code></em>.
		</div><div class="para">
			A <em class="parameter"><code>job</code></em> is the basic unit of work and has a minimum set of attributes. These attributes include the full path of the command to be executed, command arguments, job owner, and requirements that provide information to MRG Grid. The requirements list enables matching with a resource that can execute the job.
		</div><div class="para">
			A <em class="parameter"><code>submission</code></em> is an association of jobs under a common name key, such as <em class="parameter"><code>my_submission_for_today</code></em>. Aviary can generate a submission name if one is not given.
		</div><div class="para">
			An <em class="parameter"><code>attribute</code></em> describes aspects of a job. Some attributes can be set when the job is submitted or edited later when the job is still actively being processed in the MRG Grid job queue. MRG Grid will specify many job attributes after a submission but you can also provide custom attributes if they are meaningful to the execution of the application represented by a job.
		</div></div></div><div xml:lang="en-US" class="chapter" id="chap-Grid_Developer_Guide-Aviary_Installation_and_Configuration" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 3. Aviary Installation and Configuration</h2></div></div></div><div class="toc"><dl><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Installation_and_Configuration-Installation">3.1. Installation</a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Installation_and_Configuration-Configuration">3.2. Configuration</a></span></dt></dl></div><div class="section" id="sect-Grid_Developer_Guide-Aviary_Installation_and_Configuration-Installation"><div class="titlepage"><div><div><h2 class="title" id="sect-Grid_Developer_Guide-Aviary_Installation_and_Configuration-Installation">3.1. Installation</h2></div></div></div><div class="formalpara"><h5 class="formalpara" id="id3060190">RPM</h5>
				Install the <span class="package">condor-aviary</span> package for your platform. This will install the required software components, including the WSDL and schema files for Aviary. These files can be used to develop a remote web service client. 

			</div><div class="note"><div class="admonition_header"><h2>Note</h2></div><div class="admonition"><div class="para">
				Currently, due to a limitation in the underlying web service stack (Axis2/C), it is not possible to dynamically retrieve the WSDL and imported XSD over HTTP using the <code class="command">?wsdl</code> URL syntax.
			</div></div></div><div class="formalpara"><h5 class="formalpara" id="id3034170">Source</h5>
				Aviary can be included in a MRG Grid source build using the following variables when <code class="command">cmake</code> is invoked:
			</div><pre class="programlisting">
-DWANT_CONTRIB:BOOL=TRUE -DWITH_AVIARY:BOOL=TRUE
</pre></div><div class="section" id="sect-Grid_Developer_Guide-Aviary_Installation_and_Configuration-Configuration"><div class="titlepage"><div><div><h2 class="title" id="sect-Grid_Developer_Guide-Aviary_Installation_and_Configuration-Configuration">3.2. Configuration</h2></div></div></div><div class="para">
			To enable Aviary use Remote Configuration to apply the following two features to your MRG Grid pool: 
			<div class="itemizedlist"><ul><li class="listitem"><div class="para">
						<em class="parameter"><code>AviaryScheduler</code></em> - configuration to activate a component that provides the Aviary job submission and management capabilities
					</div></li><li class="listitem"><div class="para">
						<em class="parameter"><code>QueryServer</code></em> - configuration to activate a component that provides the Aviary job query capabilities
					</div></li></ul></div>

		</div><div class="para">
			Refer to the <em class="citetitle">Remote Configuration</em> chapter in the <em class="citetitle">MRG Grid User Guide</em> for information on applying features to pools.
		</div></div></div><div xml:lang="en-US" class="chapter" id="chap-Grid_Developer_Guide-Aviary_Core_Types" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 4. Aviary Core Types</h2></div></div></div><div class="toc"><dl><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Core_Types-JobID">4.1. <em class="parameter"><code>JobId</code></em></a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Core_Types-SubmissionID">4.2. <em class="parameter"><code>SubmissionId</code></em></a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Core_Types-Attribute">4.3. <em class="parameter"><code>Attribute</code></em></a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Core_Types-JobStatus">4.4. <em class="parameter"><code>JobStatus</code></em></a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Aviary_Core_Types-ResourceConstraint">4.5. <em class="parameter"><code>ResourceConstraint</code></em></a></span></dt></dl></div><div class="para">
		The XML schema defines core types that are meaningful to understanding how Aviary operations are to be invoked and how results are to be interpreted.
	</div><div class="section" id="sect-Grid_Developer_Guide-Aviary_Core_Types-JobID"><div class="titlepage"><div><div><h2 class="title" id="sect-Grid_Developer_Guide-Aviary_Core_Types-JobID">4.1. <em class="parameter"><code>JobId</code></em></h2></div></div></div><div class="para">
			A <em class="parameter"><code>JobId</code></em> is a unit of information that fully describes the identity of a job. It contains the following parameters:
		</div><div class="itemizedlist"><ul><li class="listitem"><div class="para">
					<em class="parameter"><code>job</code></em> - the local identifier for a job assigned to a specific scheduler. It is a <span class="type">string</span> that encodes two positive floating point numbers such as 1.0, 84.3, 2004.68. The first is a reference to a local job grouping that may have multiple parts with attributes in common that are counted by the second number. A typical example is a group of jobs that share the same command but pass different arguments to the command, each job then writes its outputs to a different file.
				</div></li><li class="listitem"><div class="para">
					<em class="parameter"><code>scheduler</code></em> - a <span class="type">string</span> that identifies which scheduler the job was submitted to.
				</div></li><li class="listitem"><div class="para">
					<em class="parameter"><code>pool</code></em> - a <span class="type">string</span> that identifies a MRG Grid deployment. A deployment is an arena of schedulers, job execution resources and components that match jobs to those resources.
				</div></li></ul></div></div><div class="section" id="sect-Grid_Developer_Guide-Aviary_Core_Types-SubmissionID"><div class="titlepage"><div><div><h2 class="title" id="sect-Grid_Developer_Guide-Aviary_Core_Types-SubmissionID">4.2. <em class="parameter"><code>SubmissionId</code></em></h2></div></div></div><div class="para">
			A <em class="parameter"><code>SubmissionId</code></em> is a unit of information that describes a submission in the following two parts:
		</div><div class="itemizedlist"><ul><li class="listitem"><div class="para">
					<em class="parameter"><code>name</code></em> - a string provided by the user or generated on behalf of the user at the time of submission. Submission names may be considered a way to associate and aggregate jobs in such a way that is meaningful to the developer. An example of a meaningful name may be <em class="parameter"><code>my_submission_04302011</code></em>. As submissions are open-ended, a user can continue to add individual jobs to this aggregating name over time. This remains true though the individual jobs may have been scheduled and executed at different times by MRG Grid. For example, the jobs <em class="parameter"><code>1.0</code></em>, <em class="parameter"><code>28.0</code></em> and <em class="parameter"><code>2011.0</code></em> could all be part of the submission named <em class="parameter"><code>my_submission_04302011</code></em>. 

				</div></li><li class="listitem"><div class="para">
					<em class="parameter"><code>owner</code></em> - a string containing the name of the original submitter.
				</div></li></ul></div></div><div class="section" id="sect-Grid_Developer_Guide-Aviary_Core_Types-Attribute"><div class="titlepage"><div><div><h2 class="title" id="sect-Grid_Developer_Guide-Aviary_Core_Types-Attribute">4.3. <em class="parameter"><code>Attribute</code></em></h2></div></div></div><div class="para">
			An <em class="parameter"><code>attribute</code></em> is type-coded information used by MRG Grid to evaluate, organize and execute job matching and processing. MRG Grid jobs have multiple attributes, some are user-specified before submission and many that are attached to a job by the MRG Grid infrastructure when added to the job queue. A MRG Grid job is the sum of its attributes. An <em class="parameter"><code>attribute</code></em> consists of:
		</div><div class="itemizedlist"><ul><li class="listitem"><div class="para">
					<em class="parameter"><code>name</code></em> - a string denoting the attribute name. Names can be pre-defined and understood by the MRG Grid infrastructure or a custom attribute name.
				</div></li><li class="listitem"><div class="para">
					<em class="parameter"><code>type</code></em> - an enumerated string with values string, integer, float, expression or boolean.
				</div></li><li class="listitem"><div class="para">
					<em class="parameter"><code>value</code></em> - the string form of the value.
				</div></li></ul></div></div><div class="section" id="sect-Grid_Developer_Guide-Aviary_Core_Types-JobStatus"><div class="titlepage"><div><div><h2 class="title" id="sect-Grid_Developer_Guide-Aviary_Core_Types-JobStatus">4.4. <em class="parameter"><code>JobStatus</code></em></h2></div></div></div><div class="para">
			A <em class="parameter"><code>JobStatus</code></em> exists in one of the following states: 
			<div class="itemizedlist"><ul><li class="listitem"><div class="para">
						<em class="parameter"><code>idle</code></em> - the job is in a state where it is not ready or able to be assigned to a resource.
					</div></li><li class="listitem"><div class="para">
						<em class="parameter"><code>running</code></em> - the job is assigned to and running on a resource.
					</div></li><li class="listitem"><div class="para">
						<em class="parameter"><code>held</code></em> - the job exists in the MRG Grid queue but is held back from execution.
					</div></li><li class="listitem"><div class="para">
						<em class="parameter"><code>completed</code></em> - the job ran to completion.
					</div></li><li class="listitem"><div class="para">
						<em class="parameter"><code>removed</code></em> - the job was deleted from the job queue by a user.
					</div></li></ul></div>

		</div></div><div class="section" id="sect-Grid_Developer_Guide-Aviary_Core_Types-ResourceConstraint"><div class="titlepage"><div><div><h2 class="title" id="sect-Grid_Developer_Guide-Aviary_Core_Types-ResourceConstraint">4.5. <em class="parameter"><code>ResourceConstraint</code></em></h2></div></div></div><div class="para">
			A <em class="parameter"><code>ResourceConstraint</code></em> is a basic quality that MRG Grid should consider when matching a new job to a resource. There are five basic constraints defined in Aviary which are:
		</div><div class="itemizedlist"><ul><li class="listitem"><div class="para">
					<em class="parameter"><code>OS</code></em> - <em class="parameter"><code>Linux</code></em> or <em class="parameter"><code>Windows</code></em>.
				</div></li><li class="listitem"><div class="para">
					<em class="parameter"><code>ARCH</code></em> - for 32-bit platforms, <em class="parameter"><code>INTEL</code></em>; or <em class="parameter"><code>X86_64</code></em> for 64-bit platforms. This is important when the executable needed by the job is compiled for a particular architecture.
				</div></li><li class="listitem"><div class="para">
					<em class="parameter"><code>MEMORY</code></em> - the expected total RAM required to execute the job.
				</div></li><li class="listitem"><div class="para">
					<em class="parameter"><code>DISK</code></em> - expected total disk space to execute the job.
				</div></li><li class="listitem"><div class="para">
					<em class="parameter"><code>FILESYSTEM</code></em> - the domain name representing a uniformly mounted network file system, as configured by a MRG Grid administrator.
				</div></li></ul></div></div></div><div xml:lang="en-US" class="chapter" id="chap-Grid_Developer_Guide-Job_Submission_Management" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 5. Job Submission and Management</h2></div></div></div><div class="para">
		Job Management is used for job control and reporting. Methods in job management include job submission, hold, release and removal.
	</div><div class="table" id="tabl-Grid_Developer_Guide-Job_Submission_Management-Operations"><h6>Table 5.1. Job Submission and Management Operations</h6><div class="table-contents"><table summary="Job Submission and Management Operations" border="1"><colgroup><col width="25%" /><col width="25%" /><col width="25%" /><col width="25%" /></colgroup><thead><tr><th>
						Operation
					</th><th>
						Inputs
					</th><th>
						Outputs
					</th><th>
						Notes
					</th></tr></thead><tbody><tr><td>
						<code class="command">submitJob</code>
					</td><td>
						<div class="para">
							Job submission request fields are: 
							<div class="itemizedlist"><ul><li class="listitem"><div class="para">
										<em class="parameter"><code>cmd</code></em> - a <span class="type">string</span> containing the absolute path to an executable or script
									</div></li><li class="listitem"><div class="para">
										<em class="parameter"><code>args</code></em> - an optional <span class="type">string</span> containing arguments for the <em class="parameter"><code>cmd</code></em>
									</div></li><li class="listitem"><div class="para">
										<em class="parameter"><code>owner</code></em> - a <span class="type">string</span> identifying the submitter
									</div></li><li class="listitem"><div class="para">
										<em class="parameter"><code>iwd</code></em> - the initial working directory where the job will be executed
									</div></li><li class="listitem"><div class="para">
										<em class="parameter"><code>submission_name</code></em> - an optional <span class="type">string</span> identifying the submission that should be created or that this job is to be attached to
									</div></li><li class="listitem"><div class="para">
										<em class="parameter"><code>requirements</code></em> - an optional list of <code class="command">ResourceConstraints</code> that specify what type of resource this job should be targeted at
									</div></li><li class="listitem"><div class="para">
										<em class="parameter"><code>extra</code></em> - option list of <em class="parameter"><code>Attributes</code></em> that refine the request beyond basic fields or supersede the MRG Grid Attributes implied by other basic fields in this request
									</div></li></ul></div>

						</div>

					</td><td>
						<div class="para">
							<span class="returnvalue">'OK'</span> and the <em class="parameter"><code>JobId</code></em> or an error containing diagnostic text if a problem was encountered.
						</div>

					</td><td>
						<div class="para">
							MRG Grid users familiar with crafting specific <em class="parameter"><code>attributes</code></em> such as complex requirements may do so using the <em class="parameter"><code>extra</code></em> attribute field in conjunction with the <code class="command">allowOverrides</code> XML attribute in the request.
						</div>

					</td></tr><tr><td>
						<code class="command">holdJob</code>
					</td><td>
						<div class="para">
							A single <em class="parameter"><code>JobId</code></em> and a hold reason in <span class="type">string</span> format.
						</div>

					</td><td>
						<div class="para">
							<span class="returnvalue">'OK'</span> or an error with text if the job is not found or parsed.
						</div>

					</td><td>
						<div class="para">
							A hold is a temporary interruption of job execution against a resource; holds can be used to affect job attribute edits without needing to resubmit the job.
						</div>

					</td></tr><tr><td>
						<code class="command">releaseJob</code>
					</td><td>
						<div class="para">
							A single <em class="parameter"><code>JobId</code></em> and a release reason in <span class="type">string</span> format.
						</div>

					</td><td>
						<div class="para">
							<span class="returnvalue">'OK'</span> or an error with text if the job is not found or parsed
						</div>

					</td><td>
						<div class="para">
							Releasing a job is moving it out of the held state and back where it is ready to be schedule again with a resource.
						</div>

					</td></tr><tr><td>
						<code class="command">removeJob</code>
					</td><td>
						<div class="para">
							A single <em class="parameter"><code>JobId</code></em> and a remove reason in <span class="type">string</span> format.
						</div>

					</td><td>
						<div class="para">
							<span class="returnvalue">'OK'</span> or an error with text if the job is not found or parsed.
						</div>

					</td><td>
						<div class="para">
							Job removal means that the job is prevented from executing to completion, note that its existence in the MRG Grid queue is still maintained on record.
						</div>

					</td></tr><tr><td>
						<code class="command">setJobAttribute</code>
					</td><td>
						<div class="para">
							A single <em class="parameter"><code>JobId</code></em> and a single <em class="parameter"><code>Attribute</code></em>.
						</div>

					</td><td>
						<div class="para">
							<span class="returnvalue">'OK'</span> or an error with text is the job is not found or parsed.
						</div>

					</td><td>
						<div class="para">
							Attributes are predefined by MRG Grid or can be user-created, for example a name/type/value shorthand combination: 
							<div class="itemizedlist"><ul><li class="listitem"><div class="para">
										<em class="parameter"><code>JobPrio</code></em>/<em class="parameter"><code>INTEGER</code></em>/<em class="parameter"><code>2</code></em> would be shorthand for the job attribute predefined by MRG Grid to control job priority, set to a value of 2 giving it higher priority than the default of 0
									</div></li><li class="listitem"><div class="para">
										<em class="parameter"><code>Recipe</code></em>/<em class="parameter"><code>STRING</code></em>/<em class="parameter"><code>secret sauce</code></em> would be shorthand for a custom job attribute provided by a user, meaningful to only their application and irrelevant to the MRG Grid infrastructure
									</div></li></ul></div>

						</div>

					</td></tr></tbody></table></div></div><br class="table-break" /></div><div xml:lang="en-US" class="chapter" id="chap-Grid_Developer_Guide-Job_Data_Queries" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 6. Job Data Queries</h2></div></div></div><div class="table" id="tabl-Grid_Developer_Guide-Job_Data_Queries-Queries"><h6>Table 6.1. Job Queries for Data</h6><div class="table-contents"><table summary="Job Queries for Data" border="1"><colgroup><col width="25%" /><col width="25%" /><col width="25%" /><col width="25%" /></colgroup><thead><tr><th>
						Operation
					</th><th>
						Inputs
					</th><th>
						Outputs
					</th><th>
						Notes
					</th></tr></thead><tbody><tr><td>
						<code class="command">getJobStatus</code>
					</td><td>
						<div class="para">
							Zero to many <em class="parameter"><code>JobId</code></em>s.
						</div>

					</td><td>
						<div class="para">
							Returns the current status for each <em class="parameter"><code>JobId</code></em> input, or an error indicating that the job could not be parsed or found.
						</div>

					</td><td>
						<div class="para">
							The most efficient query as it returns the least amount of data per job.
						</div>

					</td></tr><tr><td>
						<code class="command">getJobSummary</code>
					</td><td>
						<div class="para">
							Zero to many <em class="parameter"><code>JobId</code></em>s.
						</div>

					</td><td>
						<div class="para">
							Returns a summary for each <em class="parameter"><code>JobId</code></em> input, or an error indicating that the job could not be parsed or found.
						</div>

					</td><td>
						<div class="para">
							Summary returned includes: 
							<div class="itemizedlist"><ul><li class="listitem"><div class="para">
										command
									</div></li><li class="listitem"><div class="para">
										command arguments
									</div></li><li class="listitem"><div class="para">
										scheduler local time when job was added to job queue
									</div></li><li class="listitem"><div class="para">
										scheduler local time of last update to job status
									</div></li><li class="listitem"><div class="para">
										job status
									</div></li><li class="listitem"><div class="para">
										reason why job was held, released or removed
									</div></li></ul></div>

						</div>

					</td></tr><tr><td>
						<code class="command">getJobDetails</code>
					</td><td>
						<div class="para">
							Zero to many <em class="parameter"><code>JobId</code></em>s.
						</div>

					</td><td>
						<div class="para">
							Returns all <em class="parameter"><code>Attributes</code></em> for each <em class="parameter"><code>JobId</code></em> input, or an error indicating the job could not be parsed or found.
						</div>

					</td><td>
						<div class="para">
							A potentially expensive operation, it is possible to request all the attributes for all the jobs tracked in MRG Grid. If performance is a concern consider judicious use of summaries for certain job sets.
						</div>

					</td></tr><tr><td>
						<code class="command">getJobData</code>
					</td><td>
						<div class="para">
							A single <em class="parameter"><code>JobId</code></em>, the type of data file content requested (ERR, OUT, LOG), the maximum number of bytes to be returned and whether the file should be read from the front to back.
						</div>

					</td><td>
						<div class="para">
							Returns the file content requested if successful.
						</div>

					</td><td>
						<div class="para">
							Each job can specify an error file (ERR), a log file (LOG) or an output file (OUT); the log file is used by MRG Grid to monitor the job progress.
						</div>

					</td></tr><tr><td>
						<code class="command">getSubmissionSummary</code>

					</td><td>
						<div class="para">
							Zero to many <em class="parameter"><code>SubmissionId</code></em>s.
						</div>

					</td><td>
						<div class="para">
							For each valid submission returned, these job totals will be listed: 
							<div class="itemizedlist"><ul><li class="listitem"><div class="para">
										completed
									</div></li><li class="listitem"><div class="para">
										held
									</div></li><li class="listitem"><div class="para">
										idle
									</div></li><li class="listitem"><div class="para">
										removed
									</div></li><li class="listitem"><div class="para">
										running
									</div></li></ul></div>

						</div>

					</td><td>
						<div class="para">
							Individual job summaries can be included in the response by setting the XML attribute <em class="parameter"><code>includeJobSummaries</code></em> to true in the request.
						</div>

					</td></tr></tbody></table></div></div><br class="table-break" /></div><div xml:lang="en-US" class="chapter" id="chap-Grid_Developer_Guide-Security" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 7. Security</h2></div></div></div><div class="para">
		Aviary does not currently support HTTPS communication. A production deployment that requires transport-level security for authentication and encryption could place an SSL-capable reverse proxy server such as Squid in front of the Aviary web service endpoints. The reverse proxy server can be configured so that it forwards HTTPS traffic to the HTTP endpoints. Those endpoint hosts would then have their iptables configured appropriately to restrict remote access to the HTTP ports to the reverse proxy server.
	</div></div><div xml:lang="en-US" class="chapter" id="chap-Grid_Developer_Guide-Client_Examples" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 8. Client Examples</h2></div></div></div><div class="toc"><dl><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Client_Examples-SOAP">8.1. SOAP XML</a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Client_Examples-Ruby">8.2. Ruby</a></span></dt><dt><span class="section"><a href="#sect-Grid_Developer_Guide-Client_Examples-Python">8.3. Python</a></span></dt></dl></div><div class="para">
		Aviary clients can be developed using a variety of programming languages. Below are code examples of client actions using SOAP XML, Ruby and Python.
	</div><div class="section" id="sect-Grid_Developer_Guide-Client_Examples-SOAP"><div class="titlepage"><div><div><h2 class="title" id="sect-Grid_Developer_Guide-Client_Examples-SOAP">8.1. SOAP XML</h2></div></div></div><div class="para">
			The following example shows the request and response SOAP XML for a job submission.
		</div><pre class="programlisting">
&lt;soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:job="http://job.aviary.grid.redhat.com"&gt;
   &lt;soapenv:Header/&gt;
   &lt;soapenv:Body&gt;
      &lt;job:SubmitJob allowOverrides="false"&gt;
         &lt;cmd&gt;/bin/sleep&lt;/cmd&gt;
         &lt;!--Optional:--&gt;
         &lt;args&gt;40&lt;/args&gt;
	 &lt;owner&gt;<em class="replaceable"><code>ownername</code></em>&lt;/owner&gt;
         &lt;iwd&gt;/tmp&lt;/iwd&gt;
         &lt;!--Optional:--&gt;
	 &lt;submission_name&gt;<em class="replaceable"><code>my_submission</code></em>&lt;/submission_name&gt;
         &lt;!--Zero or more repetitions:--&gt;
         &lt;requirements&gt;
            &lt;type&gt;OS&lt;/type&gt;
            &lt;value&gt;LINUX&lt;/value&gt;
         &lt;/requirements&gt;
         &lt;!--Zero or more repetitions:--&gt;
         &lt;extra&gt;
            &lt;name&gt;MYDATA&lt;/name&gt;
            &lt;type&gt;STRING&lt;/type&gt;
	    &lt;value&gt;<em class="replaceable"><code>the data</code></em>&lt;/value&gt;
         &lt;/extra&gt;
      &lt;/job:SubmitJob&gt;
   &lt;/soapenv:Body&gt;
&lt;/soapenv:Envelope&gt;
</pre><pre class="programlisting">
&lt;soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/"&gt;
   &lt;soapenv:Body&gt;
      &lt;n:SubmitJobResponse xmlns:n="http://job.aviary.grid.redhat.com"&gt;
         &lt;id&gt;
            &lt;job&gt;247.0&lt;/job&gt;
            &lt;pool&gt;localhost&lt;/pool&gt;
	    &lt;scheduler&gt;<em class="replaceable"><code>username</code></em>@localhost.localdomain&lt;/scheduler&gt;
            &lt;submission&gt;
               &lt;name&gt;my_submission&lt;/name&gt;
	       &lt;owner&gt;<em class="replaceable"><code>username</code></em>&lt;/owner&gt;
            &lt;/submission&gt;
         &lt;/id&gt;
         &lt;status&gt;
            &lt;code&gt;OK&lt;/code&gt;
            &lt;text/&gt;
         &lt;/status&gt;
      &lt;/n:SubmitJobResponse&gt;
   &lt;/soapenv:Body&gt;
&lt;/soapenv:Envelope&gt;
</pre></div><div class="section" id="sect-Grid_Developer_Guide-Client_Examples-Ruby"><div class="titlepage"><div><div><h2 class="title" id="sect-Grid_Developer_Guide-Client_Examples-Ruby">8.2. Ruby</h2></div></div></div><div class="para">
			The following example shows a Ruby Savon web service client that generates a basic submission.
		</div><pre class="programlisting">
# uses Savon http://savonrb.com/
require 'rubygems'
# httpi &gt;= 0.9.2
require 'httpi'
# savon &gt;= 0.9.1
require 'savon'
require "openssl"

client = Savon::Client.new do |wsdl|
  wsdl.document = "/var/lib/condor/aviary/services/job/aviary-job.wsdl"
  wsdl.endpoint = "http://localhost:9090/services/job/submitJob"
end

xml =  Builder::XmlMarkup.new
xml.cmd("/bin/sleep")
xml.args("40")
xml.owner("condor")
xml.iwd("/tmp")

response = client.request :job, "SubmitJob" do
    soap.namespaces["xmlns:job"] = "http://job.aviary.grid.redhat.com"
    soap.body = xml.target!
end
</pre></div><div class="section" id="sect-Grid_Developer_Guide-Client_Examples-Python"><div class="titlepage"><div><div><h2 class="title" id="sect-Grid_Developer_Guide-Client_Examples-Python">8.3. Python</h2></div></div></div><div class="para">
			The following example shows a Python Suds web service client that invokes a job query operation based on user input. This operation also takes an optional <em class="parameter"><code>JobID</code></em> argument.
		</div><pre class="programlisting">
# uses Suds - https://fedorahosted.org/suds/
import logging
from suds import *
from suds.client import Client
from sys import exit, argv, stdin
import time

# enable these to see the SOAP messages
#logging.basicConfig(level=logging.INFO)
#logging.getLogger('suds.client').setLevel(logging.DEBUG)

# change these for other default locations and ports
job_wsdl = 'file:/var/lib/condor/aviary/services/query/aviary-query.wsdl'

cmds = ['getJobStatus', 'getJobSummary', 'getJobDetails']

cmdarg = len(argv) &gt; 1 and argv[1]
cproc =  len(argv) &gt; 2 and argv[2]
job_url = len(argv) &gt; 3 and argv[3] or "http://localhost:9091/services/query/"

if cmdarg not in cmds:
    print "error unknown command: ", cmdarg
    print "available commands are: ",cmds
    exit(1)

client = Client(job_wsdl);
job_url += cmdarg
client.set_options(location=job_url)

# enable to see service schema
#print client

# set up our JobID
if cproc:
    jobId = client.factory.create("ns0:JobID")
    jobId.job = cproc
else:
    # returns all jobs
    jobId = None

try:
    func = getattr(client.service, cmdarg, None)
    if callable(func):
        result = func(jobId)
except Exception, e:
    print "invocation failed: ", job_url
    print e
    exit(1)

print result
</pre></div></div><div xml:lang="en-US" class="chapter" id="chap-Grid_Developer_Guide-More_Information" lang="en-US"><div class="titlepage"><div><div><h2 class="title">Chapter 9. More Information</h2></div></div></div><div class="orderedlist" id="orde-Grid_Developer_Guide-More_Information-Reporting_Bugs"><h6>Reporting Bugs</h6><div class="para">
			Follow these instructions to enter a bug report:
		</div><ol><li class="listitem"><div class="para">
				You will need a <a href="https://bugzilla.redhat.com/index.cgi">Bugzilla</a> account. You can create one at <a href="https://bugzilla.redhat.com/createaccount.cgi">Create Bugzilla Account</a>.
			</div></li><li class="listitem"><div class="para">
				Once you have a Bugzilla account, log in and click on <a href="https://bugzilla.redhat.com/enter_bug.cgi">Enter A New Bug Report</a>.
			</div></li><li class="listitem"><div class="para">
				You will need to identify the product (Red Hat Enterprise MRG), the version (2.0), and whether the bug occurs in the software (component=grid) or in the documentation (component=Grid_Developer_Guide).
			</div></li></ol></div><div class="variablelist" id="vari-Grid_Installation_Guide-More_Information-Further_Reading"><h6>Further Reading</h6><dl><dt class="varlistentry"><span class="term">Red Hat Enterprise MRG and MRG Grid Product Information</span></dt><dd><div class="para">
					<a href="http://www.redhat.com/mrg">http://www.redhat.com/mrg</a>
				</div></dd><dt class="varlistentry"><span class="term"><em class="citetitle">MRG Grid User Guide</em> and other Red Hat Enterprise MRG manuals</span></dt><dd><div class="para">
					<a href="http://docs.redhat.com/docs/en-US/index.html">http://docs.redhat.com/docs/en-US/index.html</a>
				</div></dd><dt class="varlistentry"><span class="term">Condor Manual</span></dt><dd><div class="para">
					<a href="http://www.cs.wisc.edu/condor/manual/">http://www.cs.wisc.edu/condor/manual/</a>
				</div></dd><dt class="varlistentry"><span class="term">Red Hat Knowledgebase</span></dt><dd><div class="para">
					<a href="https://access.redhat.com/knowledge/search">https://access.redhat.com/knowledge/search</a>
				</div></dd></dl></div></div><div xml:lang="en-US" class="appendix" id="appe-Grid_Developer_Guide-Revision_History" lang="en-US"><div class="titlepage"><div><div><h1 class="title">Revision History</h1></div></div></div><div class="para">
		<div class="revhistory"><table border="0" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="3"><strong>Revision History</strong></th></tr><tr><td align="left">Revision 1-3</td><td align="left">Wed Sep 07 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>Prepared for publishing</td></tr></table>

				</td></tr><tr><td align="left">Revision 1-2</td><td align="left">Tue Aug 23 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>BZ#731649 - Change getSubmissionSummaries to getSubmissionSummary</td></tr></table>

				</td></tr><tr><td align="left">Revision 1-1</td><td align="left">Thu Jun 23 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>Prepared for publishing</td></tr></table>

				</td></tr><tr><td align="left">Revision 1-0</td><td align="left">Thu Jun 23 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>Prepared for publishing</td></tr></table>

				</td></tr><tr><td align="left">Revision 0.1-5</td><td align="left">Thu Jun 02 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>BZ#674385 - Minor updates</td></tr></table>

				</td></tr><tr><td align="left">Revision 0.1-4</td><td align="left">Mon May 09 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>Minor XML updates</td></tr></table>

				</td></tr><tr><td align="left">Revision 0.1-3</td><td align="left">Thu May 05 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>BZ#674385- Restructured book and inserted additional source content provided</td></tr></table>

				</td></tr><tr><td align="left">Revision 0.1-2</td><td align="left">Wed Mar 30 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>Inserted Submit, Hold and Release method descriptions in Job Management</td></tr></table>

				</td></tr><tr><td align="left">Revision 0.1-1</td><td align="left">Thu Mar 3 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>Added skeleton chapters and sections</td></tr></table>

				</td></tr><tr><td align="left">Revision 0.1-0</td><td align="left">Thu Mar 3 2011</td><td align="left"><span class="author"><span class="firstname">Alison</span> <span class="surname">Young</span></span></td></tr><tr><td align="left" colspan="3">
					<table border="0" summary="Simple list" class="simplelist"><tr><td>Initial creation of book by publican</td></tr></table>

				</td></tr></table></div>

	</div></div></div></body></html>
